/* *****************************************************************************
 * 
 * Description: Takes at least one command-line argument. Demonstrates:
 *               1. How to exchange elements of an array
 *               2. Two ways of reversing elements in an array
 *
 *              Example:
 *              > java-introcs Reverse Alice Bob Carol Doug
 *              ----- TEST exchange() ------
 *              args[]   before exchange() = Alice Bob   Carol Doug
 *              args[]   after  exchange() = Doug  Bob   Carol Alice
 *              ----- TEST reverse1() ------
 *              args[]   before reverse1() = Doug  Bob   Carol Alice
 *              args[]   after  reverse1() = Doug  Bob   Carol Alice
 *              result[] after  reverse1() = Alice Carol Bob   Doug
 *              ----- TEST reverse2() ------
 *              args[]   before reverse2() = Doug  Bob   Carol Alice
 *              args[]   after  reverse2() = Alice Carol Bob   Doug
 * 
 **************************************************************************** */

public class Reverse {
    // swaps array elements i and j
    public static void exchange(String[] a, int i, int j) {
        // your code goes here
    }

    // reverse1() takes an array of Strings, and returns a new array of Strings
    // that contains the same elements as the original, but in reverse order.
    // Note: reverse1() must NOT alter the original array.
    public static String[] reverse1(String[] original) {
        // your code goes here        
        return original; // this return statement needs to be corrected

    }

    // reverse2() takes an array of Strings and reverses the order of its elements
    // by modifying the original array. This method does not return anything!
    public static void  reverse2(String[] values) {
        // your code goes here

        return;

    }
    // print all the Strings in the input array
    public static void printAll(String[] a) {
        for (int i = 0; i < a.length; i++) {
            StdOut.printf("%-6s", a[i]);
        }
        StdOut.println();
    }

    // test client
    public static void main(String[] args) {
        // print args
        StdOut.println("----- TEST exchange() ------");
        StdOut.print("args[]   before exchange() = ");
        printAll(args);
        // exchange the first and last elements
        exchange(args, 0, args.length - 1);
        StdOut.print("args[]   after  exchange() = ");
        printAll(args);

        StdOut.println("----- TEST reverse1() ------");
        StdOut.print("args[]   before reverse1() = ");
        printAll(args);

        // reverse1() does not change args[]
        String[] result = reverse1(args);
        StdOut.print("args[]   after  reverse1() = ");
        printAll(args);
        StdOut.print("result[] after  reverse1() = ");
        printAll(result);

        // reverse2() modifies args[]!
        StdOut.println("----- TEST reverse2() ------");
        StdOut.print("args[]   before reverse2() = ");
        printAll(args);
        reverse2(args);
        StdOut.print("args[]   after  reverse2() = ");
        printAll(args);
    }
}
