/* *****************************************************************************
 *
 *  Description: A collection of functions that operates on rectangular (m x n)                                *               arrays.   
 * 
 *  Based on https://introcs.cs.princeton.edu/java/stdlib/StdArrayIO.java
 *  See https://introcs.cs.princeton.edu/java/11cheatsheet/#Arrays2D
 *  See textbook 106-111
 *
 *  > java-introcs TwoDArrays
 *     2 3 
 *     1 2 3 4 5 6 
 *     Array: 2 rows x 3 columns
 *     1.00000   2.00000   3.00000 
 *     4.00000   5.00000   6.00000 
 *     Row 1:   4.00000   5.00000   6.00000 
 *     Column 1:   2.00000   5.00000 
 *
 **************************************************************************** */

public class TwoDArrays {
    // First reads the number of rows and columns.
    // Then reads a 2D array of doubles of rows x columns from standard input
    // and returns it.
    public static double[][] readDouble2D() {
        int rows = StdIn.readInt();
        int cols = StdIn.readInt();
        double____ a = new double[_][_];
        for (int i = 0; i < __; i++) {
            for (int j = 0; j < __; j++) {
                a[i][j] = StdIn.readDouble();
            }
        }
        return _____;
    }

    // Prints the 2D array of doubles to standard output.
    public static void printAll(_____ a) {
        int rows = a________;    // number of rows
        int cols = a________;   // number of columns
        StdOut.println("Array: " +  rows + " rows x " + cols + " columns");
        for (int i = 0; i < __; i++) {
            for (int j = 0; j < __; j++) {
                StdOut.printf("%9.5f ", a[__][__]);
            }
            StdOut.println();
        }
    }


    // Prints the ith row of a 2D array of doubles to standard output.
    public static void printRow(double[][] a, int row) {
        StdOut.print("Row " + row + ": ");
        int columns = a[__].length;
        for (int i = 0; i < _______; i++)
            StdOut.printf("%9.5f ", a[__][__]);
        StdOut.println();
    }

    // Prints the ith column of a 2D array of doubles to standard output.
    public static void printColumn(double[][] a, int col) {
        StdOut.print("Col " + col + ": ");
        int rows = a.______;
        for (int i = 0; i < ________; i++)
            StdOut.printf("%9.5f ", ______);
        StdOut.println();
    }


    // main client with test cases
    public static void main(String[] args) {
        // read and print a matrix of doubles
        double[][] b = readDouble2D();
        printAll(b);

        // print row 1
        printRow(b, 1);

        // print column 1
        printColumn(b, 1);
    }
}
